//Indicator: iMarketProfile2_7
//Author: Adrien (hegh2000)
//Version: 2.0
//Originale version : MarketProfile1.2 (Sartis23)

#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    public class iMarketProfile2_7 : Indicator
    {
        #region Variables
			private double		OpenSessionPrice	= 0;
			private double		TPOPrice			= 0;
			private double		TPOLowZone			= 0;
			private double		TPOHighZone			= 0;
		
			private int			TPOValZone			= 70;
			private int			CenterIndex			= 0;
			private int			UpIndex				= 0;
			private int			DnIndex				= 0;
			private int			HighIndex			= 0;
			private int			LowIndex			= 0;
			private int			TPOHigh				= 0;
			private int 		BarCount			= 0;
			private int			TPOIndex			= 0;
			private int			TPOZone				= 0;
			private int			TPOvzHigh			= 0;
			private int			TPOvzLow			= 0;
			private int			SessionCount		= 0;
			private int			PriceInterval		= 0;
			private int 		TempBar				= 0;
		
			private int			ArrayIndex			= 0;
			private int			ArrayMid			= 25000;
			private int			TPOTotal			= 0;
		
		
			private bool		Tracker 			= false;
			private bool		FirstStart			= true;
			private bool 		CalcVar				= false;
	
			private int [] TextTrack = new int[50000]; 
			private int [] TextIndex = new int[50000]; 
		
			private System.Drawing.Font textFont, Arrow;
			private Color				TPOColor = Color.Black, TPOFColor = Color.Black, COLORVA = Color.Green, COLORhVA   = Color.Orange, COLORPOC   = Color.Red;
			private DateTime			mDate ,startTime, endTime, tmpstartTime , tmpendTime, nextMonday, lundi, mardi, mercredi, jeudi, currentDate = DateTime.Today, mergeDate = new DateTime(2011, 1, 3);
			private int 				hTPOF =0, bTPOF=0, OPACITY = 6, OPENHOUR = 8 ,OPENMINUTE = 0, compteur =0;
			private double 				nVolumeTot = 0, nVolumeTotS = 0, nVolumeJ = 0, nVolumeTotM = 0, prevPOC = 0, espace  = 0, IBCoef1 = 1, IBCoef2 = 2, IBCoef3 = 3, IBCoef4 = 4;
			private double 				h = 0, l = 0 , c = 0, highestHigh = 0, lowestLow = 0, nPOC = 0, nVAh = 0, nVAb = 0, sessionLengthHours = 14;
			private bool				iPOCVA = true, iRF = true, iTPOCount = true, iVolume = true,tmpFirstStart			= true, firstDay = false, LEFTTORIGHT = true, merge = false, cmerge = true, IBPPERSIATANT = false, SHOWIBEXT	= false, LETTRE = false;
			private int 				TAILLEL = 5, PROFILE = 1, nBars = 0 , nDigitLength = 0, MODE = 0, nouveauMois = 0, ancienMois = 0, derPosL = 0, derPos = 0, firstBars = 0;
			private int 				WIDTHhpb = 0, WIDTHTPOC = 0, WIDTHTRF = 0, WIDTHTVol = 0, HIGHVol = 0, HIGHRF = 0, HIGHTPOC = 0;
			private string 				TPOT = "A", nDigit;
			private string 				letters 			= ("1ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
		#endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Blue), PlotStyle.Line, "IB_High"));
			Add(new Plot(Color.FromKnownColor(KnownColor.Blue), PlotStyle.Line, "IB_Low"));
			Add(new Plot(Color.FromKnownColor(KnownColor.Green), PlotStyle.Line, "ValueArea_High"));
			Add(new Plot(Color.FromKnownColor(KnownColor.HotPink), PlotStyle.Line, "ValueArea_Low"));
			Add(new Plot(Color.FromKnownColor(KnownColor.Red), PlotStyle.Line, "POC"));
			if (SHOWIBEXT)
			{
				Add(new Plot(Color.FromKnownColor(KnownColor.DarkGray), PlotStyle.Line, "IB_Ext_h1"));
				Add(new Plot(Color.FromKnownColor(KnownColor.DarkGray), PlotStyle.Line, "IB_Ext_h2"));
				Add(new Plot(Color.FromKnownColor(KnownColor.DarkGray), PlotStyle.Line, "IB_Ext_h3"));
				Add(new Plot(Color.FromKnownColor(KnownColor.DarkGray), PlotStyle.Line, "IB_Ext_h4"));
				Add(new Plot(Color.FromKnownColor(KnownColor.DarkGray), PlotStyle.Line, "IB_Ext_l1"));
				Add(new Plot(Color.FromKnownColor(KnownColor.DarkGray), PlotStyle.Line, "IB_Ext_l2"));
				Add(new Plot(Color.FromKnownColor(KnownColor.DarkGray), PlotStyle.Line, "IB_Ext_l3"));
				Add(new Plot(Color.FromKnownColor(KnownColor.DarkGray), PlotStyle.Line, "IB_Ext_l4"));
			}

            CalculateOnBarClose	= true;
            Overlay				= true;
			DrawOnPricePanel = false;
			Arrow = new Font("Wingdings 3",8);
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			if (MODE == 1)
			{
				if  (CurrentBar == 0)
				{
					startTime = new DateTime(Time[0].Year, Time[0].Month, Time[0].Day, OPENHOUR, OPENMINUTE, 0);
					endTime = startTime.AddDays(5);
					
					tmpstartTime = startTime;
					if (sessionLengthHours >= 24)
						tmpendTime = tmpstartTime.AddHours(24.0-1.0/60.0);
					else
						tmpendTime = tmpstartTime.AddHours(sessionLengthHours);

					if (sessionLengthHours >= 24)
						endTime = endTime.AddHours(24.0-1.0/60.0);
					else
						endTime = endTime.AddHours(sessionLengthHours);
				}
				
				if  (CurrentBar >= 1) 
				{
					if (Bars.DayBreak && Time[0].DayOfWeek == DayOfWeek.Monday)
						firstDay = true;
					else if (Bars.DayBreak && Time[0].DayOfWeek == DayOfWeek.Tuesday)
					{
						lundi = new DateTime(Time[0].Year, Time[0].Month, Time[0].Day, OPENHOUR, OPENMINUTE, 0);
						if (GetBar(lundi.AddDays(-1)) == 0)	
							firstDay = true;
					}
					else if (Bars.DayBreak && Time[0].DayOfWeek == DayOfWeek.Wednesday)
					{
						mardi = new DateTime(Time[0].Year, Time[0].Month, Time[0].Day, OPENHOUR, OPENMINUTE, 0);
						if ((GetBar(mardi.AddDays(-1)) == 0) && (GetBar(lundi.AddDays(-1)) == 0))	
							firstDay = true;
					}
					else if (Bars.DayBreak && Time[0].DayOfWeek == DayOfWeek.Thursday)
					{
						mercredi = new DateTime(Time[0].Year, Time[0].Month, Time[0].Day, OPENHOUR, OPENMINUTE, 0);
						if ((GetBar(mercredi.AddDays(-1)) == 0) && (GetBar(mardi.AddDays(-1)) == 0) && (GetBar(lundi.AddDays(-1)) == 0))	
							firstDay = true;
					}
					else if (Bars.DayBreak && Time[0].DayOfWeek == DayOfWeek.Friday)
					{
						jeudi = new DateTime(Time[0].Year, Time[0].Month, Time[0].Day, OPENHOUR, OPENMINUTE, 0);
						if ((GetBar(jeudi.AddDays(-1)) == 0) && (GetBar(mercredi.AddDays(-1)) == 0) && (GetBar(mardi.AddDays(-1)) == 0) && (GetBar(lundi.AddDays(-1)) == 0))	
							firstDay = true;
					}

					if (firstDay)
					{
						compteur = compteur + 1;
						FirstStart = true;
						tmpFirstStart = false;
						firstDay = false;
					}
					
					if (FirstStart == true && ToTime(Time[0]) > ToTime(startTime) && ToTime(Time[0]) <= ToTime(endTime) && Time[0].DayOfWeek != DayOfWeek.Sunday && Time[0].DayOfWeek != DayOfWeek.Saturday && SessionCount < compteur)
					{
						nPOC = TPOPrice;
						nVAh = TPOHighZone;
						nVAb = TPOLowZone;
						if (PROFILE == 0 || PROFILE == 1)
							DrawProfile();
						InitVar();
					}
			
					
					if (ToTime(Time[0]) > ToTime(tmpendTime) && tmpFirstStart == false)
					{
						tmpstartTime = tmpstartTime.AddDays(1);
						tmpFirstStart = true;
					if (sessionLengthHours >= 24)
						tmpendTime = tmpstartTime.AddHours(24.0-1.0/60.0);
					else
						tmpendTime = tmpstartTime.AddHours(sessionLengthHours);
						

					}
					if (ToTime(Time[0]) > ToTime(tmpstartTime) && tmpFirstStart == true && ToTime(Time[0]) <= ToTime(tmpendTime))
						tmpFirstStart = false;
					
					if (FirstStart == false && tmpFirstStart == false ) 
					{
						MP();
						if (FirstStart == false && (PROFILE == 0 || PROFILE == 1))
							DrawProfile();
						if (PROFILE == 1)
						{
							DiversAffichage();
							if (iTPOCount)
								TPOCount();
							if (iRF)
								TPOF();
						}
					}
					if (PROFILE == 2)
					{
						if (nPOC > 0)
						{
							POC.Set(nPOC);
							ValueArea_High.Set(nVAh);
							ValueArea_Low.Set(nVAb);
						}
					}
					else if (PROFILE == 3)
					{
						if (nPOC > 0)
							{
								POC.Set(nPOC);
								ValueArea_High.Set(nVAh);
								ValueArea_Low.Set(nVAb);
							}
						DrawText("VAht", TPOHighZone.ToString(), 0, TPOHighZone, Color.Green);
						DrawText("VAbt", TPOLowZone.ToString(), 0, TPOLowZone, Color.HotPink);
						DrawText("POCt", TPOPrice.ToString(), 0, TPOPrice, Color.Red);
					}

				}
			} // fin mode 1
			else if (MODE == 2)
			{			
				startTime = new DateTime(Time[0].Year, Time[0].Month, 1);
				startTime = new DateTime(Time[0].Year, startTime.Month, startTime.Day, OPENHOUR, OPENMINUTE, 0);
				
				tmpstartTime = startTime;
				if (sessionLengthHours >= 24)
					tmpendTime = tmpstartTime.AddHours(24.0-1.0/60.0);
				else
					tmpendTime = tmpstartTime.AddHours(sessionLengthHours);
	
				endTime = RoundUpTimeToPeriodTime(Time[0].Date);
				nouveauMois = endTime.Month;
				if (sessionLengthHours >= 24)
					endTime = endTime.AddHours(24.0-1.0/60.0);
				else
					endTime = endTime.AddHours(sessionLengthHours);

				if  (CurrentBar >= 1) 
				{
					if (Bars.DayBreak && nouveauMois != ancienMois)
					{
						nPOC = TPOPrice;
						nVAh = TPOHighZone;
						nVAb = TPOLowZone;
						compteur = compteur + 1;
						if (PROFILE == 0 || PROFILE == 1)
							DrawProfile();
						InitVar();
					}
					
					if (ToTime(Time[0]) > ToTime(tmpendTime) && tmpFirstStart == false)
					{
						tmpstartTime = tmpstartTime.AddDays(1);
						tmpFirstStart = true;
						if (sessionLengthHours >= 24)
							tmpendTime = tmpstartTime.AddHours(24.0-1.0/60.0);
						else
							tmpendTime = tmpstartTime.AddHours(sessionLengthHours);
					}
					if (ToTime(Time[0]) > ToTime(tmpstartTime) && tmpFirstStart == true && ToTime(Time[0]) <= ToTime(tmpendTime))
						tmpFirstStart = false;
					
					if (FirstStart == false && tmpFirstStart == false) 
					{						
						MP();
						if (FirstStart == false && (PROFILE == 0 || PROFILE == 1) && (CurrentBar + 2 >= Bars.Count))
							DrawProfile();
						if (PROFILE == 1)
						{
							if (iRF)
								TPOF();
							if (iTPOCount)
								TPOCount();
							DiversAffichage();
						}
					}
					if (PROFILE == 2)
					{
						if (nPOC > 0)
						{
							POC.Set(nPOC);
							ValueArea_High.Set(nVAh);
							ValueArea_Low.Set(nVAb);
						}
					}
					else if (PROFILE == 3)
					{
						if (nPOC > 0)
							{
								POC.Set(nPOC);
								ValueArea_High.Set(nVAh);
								ValueArea_Low.Set(nVAb);
							}
						DrawText("VAht", TPOHighZone.ToString(), 0, TPOHighZone, Color.Green);
						DrawText("VAbt", TPOLowZone.ToString(), 0, TPOLowZone, Color.HotPink);
						DrawText("POCt", TPOPrice.ToString(), 0, TPOPrice, Color.Red);
					}
	
				}
			} // fin mode 2
			else // mode 0
			{
				if  (CurrentBar == 0) 
				{
					startTime = new DateTime(Time[0].Year, Time[0].Month, Time[0].Day, OPENHOUR, OPENMINUTE, 0);
					if (sessionLengthHours >= 24)
						endTime = startTime.AddHours(24.0-1.0/60.0);
					else
						endTime = startTime.AddHours(sessionLengthHours);
					mDate = new DateTime(mergeDate.Year, mergeDate.Month, mergeDate.Day, OPENHOUR, OPENMINUTE, 0);
				}
	
				if  (CurrentBar > 1) 
				{
					if (Bars.DayBreak)
					{
						if (merge)
						{
							firstBars = GetBar(mDate);
							if (firstBars == 0)
							{
								
								compteur = compteur + 1;
								FirstStart = true;
							}
						}
						else
						{
							compteur = compteur + 1;
							FirstStart = true;
						}
					}
					if (merge)
					{
						if (FirstStart == true && ToTime(Time[0]) > ToTime(startTime) && ToTime(Time[0]) <= ToTime(endTime) && Time[0].DayOfWeek != DayOfWeek.Sunday && Time[0].DayOfWeek != DayOfWeek.Saturday && SessionCount < compteur)
						{
							nPOC = TPOPrice;
							nVAh = TPOHighZone;
							nVAb = TPOLowZone;
							if (PROFILE == 0 || PROFILE == 1)
								DrawProfile();
							InitVar();
						}
					}
					else if (FirstStart == true && ToTime(Time[0]) > ToTime(startTime) && ToTime(Time[0]) <= ToTime(endTime) && Time[0].DayOfWeek != DayOfWeek.Sunday && Time[0].DayOfWeek != DayOfWeek.Saturday && SessionCount < compteur)
					{
						nPOC = TPOPrice;
						nVAh = TPOHighZone;
						nVAb = TPOLowZone;
						if (PROFILE == 0 || PROFILE == 1)
							DrawProfile();
						InitVar();
					}
			
					if (ToTime(Time[0]) > ToTime(endTime)) FirstStart = true;
					
					if (FirstStart == false) 
					{
						if (TPOPrice != 0)
							prevPOC = TPOPrice;
						MP();
						if (FirstStart == false && (PROFILE == 0 || PROFILE == 1) && (SessionCount < compteur))
							DrawProfile();
						if (PROFILE == 1)
						{
							CalculateIB(h,l);
							if (iTPOCount)
								TPOCount();
							if (iRF)
								TPOF();
							DiversAffichage();
						}
						if (TPOPrice != 0)
							prevPOC = TPOPrice;
					}
					if (PROFILE == 2)
					{
						if (nPOC > 0)
						{
							POC.Set(nPOC);
							ValueArea_High.Set(nVAh);
							ValueArea_Low.Set(nVAb);
						}
					}
					else if (PROFILE == 3)
					{
						if (nPOC > 0)
							{
								POC.Set(nPOC);
								ValueArea_High.Set(nVAh);
								ValueArea_Low.Set(nVAb);
							}
						DrawText("VAht", TPOHighZone.ToString(), 0, TPOHighZone, Color.Green);
						DrawText("VAbt", TPOLowZone.ToString(), 0, TPOLowZone, Color.HotPink);
						DrawText("POCt", TPOPrice.ToString(), 0, TPOPrice, Color.Red);
					}
				}
			} // fin mode 0
        }

        #region Properties
		[Description("sessionLengthHours")]
        [Category("Settings : Time")]
		[Gui.Design.DisplayName("Session Length Hours")]
        public double SessionLengthHours
        {
            get { return sessionLengthHours; }
            set { sessionLengthHours = Math.Max(1, Math.Min(value, 24)); }
        }
		[Description("Opacity Color")]
        [Category("Settings : Colors")]
		[Gui.Design.DisplayName("\tOpacity")]
        public int Opacity
        {
            get { return OPACITY; }
            set { OPACITY = Math.Max(0, value); }
        }
		[Description("Value Zone Percentage")]
        [Category("Settings : Profile")]
		[Gui.Design.DisplayName("\t\t\tValueArea %")]
        public int TPOvalzone
        {
            get { return TPOValZone; }
            set { TPOValZone = Math.Max(1, Math.Min(value, 100)); }
        }
		[Description("Market open hour")]
        [Category("Settings : Time")]
		[Gui.Design.DisplayName("Open Hour")]
        public int OpenHour
        {
            get { return OPENHOUR; }
			set { OPENHOUR = Math.Max(0,Math.Min(value, 24));}
        }
        [Description("Market open minute")]
        [Category("Settings : Time")]
		[Gui.Design.DisplayName("Open Minute")]
        public int OpenMinute
        {
            get { return OPENMINUTE; }
			set { OPENMINUTE = Math.Max(0,Math.Min(value, 60));}
        }
		[Browsable(false)]
        [XmlIgnore()]
        public DataSeries IB_High
        {
            get { return Values[0]; }
        }
		[Browsable(false)]	
        [XmlIgnore()]
        public DataSeries IB_Low
        {
            get { return Values[1]; }
        }
		[Browsable(false)]	
        [XmlIgnore()]
        public DataSeries ValueArea_High
        {
            get { return Values[2]; }
        }
		[Browsable(false)]	
        [XmlIgnore()]
        public DataSeries ValueArea_Low
        {
            get { return Values[3]; }
        }
		[Browsable(false)]	
        [XmlIgnore()]
        public DataSeries POC
        {
            get { return Values[4]; }
        }
		[Browsable(false)]
        [XmlIgnore()]
        public DataSeries IB_Ext_h1
        {
            get { return Values[5]; }
        }
		[Browsable(false)]
        [XmlIgnore()]
        public DataSeries IB_Ext_h2
        {
            get { return Values[6]; }
        }
		[Browsable(false)]
        [XmlIgnore()]
        public DataSeries IB_Ext_h3
        {
            get { return Values[7]; }
        }
		[Browsable(false)]
        [XmlIgnore()]
        public DataSeries IB_Ext_h4
        {
            get { return Values[8]; }
        }
		[Browsable(false)]
        [XmlIgnore()]
        public DataSeries IB_Ext_l1
        {
            get { return Values[9]; }
        }
		[Browsable(false)]
        [XmlIgnore()]
        public DataSeries IB_Ext_l2
        {
            get { return Values[10]; }
        }
		[Browsable(false)]
        [XmlIgnore()]
        public DataSeries IB_Ext_l3
        {
            get { return Values[11]; }
        }
		[Browsable(false)]
        [XmlIgnore()]
        public DataSeries IB_Ext_l4
        {
            get { return Values[12]; }
        }
		[Description("0=Daily, 1=Weekly,2=Montly")]
        [Category("Settings : Profile")]
		[Gui.Design.DisplayName("\t\t\t\t\tMode")]
        public int Mode
        {
            get { return MODE; }
            set { MODE = Math.Max(0, Math.Min(value, 3)); }
        }
		[Description("0 : Profile without text, 1 : Profie with texte, 2 : last values on plots, 3 : last values on plot + current values on text")]
        [Category("Settings : Profile")]
		[Gui.Design.DisplayName("\t\t\t\tType")]
        public int Profile
        {
            get { return PROFILE; }
            set { PROFILE = Math.Max(0, Math.Min(value, 3)); }
        }
		[Description("true : Profile LeftToRight, falseRifhtToLeft")]
        [Category("Settings : Profile")]
		[Gui.Design.DisplayName("\t\tLeft To Right")]
        public bool LeftToRight
        {
            get { return LEFTTORIGHT; }
            set { LEFTTORIGHT = value; }
        }
		[Description("true : Draw all IB, false = CurrentDay draw")]
        [Category("Settings : Initial Balance")]
		[Gui.Design.DisplayName("\t\tPersistant")]
        public bool IBPersistant
        {
            get { return IBPPERSIATANT; }
            set { IBPPERSIATANT = value; }
        }
		[Description("true : Draw all IB extention")]
        [Category("Settings : Initial Balance")]
		[Gui.Design.DisplayName("\tShow Extention")]
        public bool ShowIBext
        {
            get { return SHOWIBEXT; }
            set { SHOWIBEXT = value; }
        }
		[Description("Coef1")]
        [Category("Settings : Initial Balance")]
		[Gui.Design.DisplayName("Extention Multiplier 1")]
        public double Coef1
        {
            get { return IBCoef1; }
            set { IBCoef1 = Math.Max(0, value); }
        }
		[Description("Coef2")]
        [Category("Settings : Initial Balance")]
		[Gui.Design.DisplayName("Extention Multiplier 2")]
        public double Coef2
        {
            get { return IBCoef2; }
            set { IBCoef2 = Math.Max(0, value); }
        }
		[Description("Coef3")]
        [Category("Settings : Initial Balance")]
		[Gui.Design.DisplayName("Extention Multiplier 3")]
        public double Coef3
        {
            get { return IBCoef3; }
            set { IBCoef3 = Math.Max(0, value); }
        }
		[Description("Coef4")]
        [Category("Settings : Initial Balance")]
		[Gui.Design.DisplayName("Extention Multiplier 4")]
        public double Coef4
        {
            get { return IBCoef4; }
            set { IBCoef4 = Math.Max(0, value); }
        }
		[Description("Size Lettre")]
        [Category("Settings : Lettre")]
		[Gui.Design.DisplayName("Size")]
        public int SizeLettre
        {
            get { return TAILLEL; }
            set { TAILLEL = Math.Max(1, value); }
        }
		[Description("false = Rectangle, true = Lettre")]
        [Category("Settings : Lettre")]
		[Gui.Design.DisplayName("\tDisplay")]
        public bool Lettre
        {
            get { return LETTRE; }
            set { LETTRE = value; }
        }
		[Description("Distance POC, VA_h, VA_b text from profile")]
        [Category("Settings : POC & VA (text)")]
		[Gui.Design.DisplayName("Width")]
        public int Widthhpb
        {
            get { return WIDTHhpb; }
            set { WIDTHhpb = Math.Max(-100, value); }
        }
		[Description("Distance TPOCount text from profile")]
        [Category("Settings : TPOCount")]
		[Gui.Design.DisplayName("Width")]
        public int Widthtpoc
        {
            get { return WIDTHTPOC; }
            set { WIDTHTPOC = Math.Max(-100, value); }
        }
		[Description("Distance Rotation Factor text from profile")]
        [Category("Settings : Rotation Factor")]
		[Gui.Design.DisplayName("Width")]
        public int Widthtrf
        {
            get { return WIDTHTRF; }
            set { WIDTHTRF = Math.Max(-100, value); }
        }
		[Description("Distance Volume text from profile")]
        [Category("Settings : Volume")]
		[Gui.Design.DisplayName("Width")]
        public int WidthVol
        {
            get { return WIDTHTVol; }
            set { WIDTHTVol = Math.Max(-100, value); }
        }
		[Description("High Volume text from profile")]
        [Category("Settings : Volume")]
		[Gui.Design.DisplayName("Height")]
        public int HighVol
        {
            get { return HIGHVol; }
            set { HIGHVol = Math.Max(-100, value); }
        }
		[Description("High Rotation Factor text from profile")]
        [Category("Settings : Rotation Factor")]
		[Gui.Design.DisplayName("Height")]
        public int HighRF
        {
            get { return HIGHRF; }
            set { HIGHRF = Math.Max(-100, value); }
        }
		[Description("High TPOCount text from profile")]
        [Category("Settings : TPOCount")]
		[Gui.Design.DisplayName("Height")]
        public int HighTPOC
        {
            get { return HIGHTPOC; }
            set { HIGHTPOC = Math.Max(-100, value); }
        }
		[Description("Merge Start Date")]
		[Category("Settings : Merge : Daily")]
		[Gui.Design.DisplayName("Merge Date")]
		public DateTime MergeDate
		{
			get { return mergeDate; }
			set { mergeDate = value; }
		}
		[Description("true : Merge from Date")]
        [Category("Settings : Merge : Daily")]
        public bool Merge
        {
            get { return merge; }
            set { merge = value; }
        }
		[Description("VA Color")]
        [Category("Settings : Colors")]
		[Gui.Design.DisplayName("ValueArea")]
        public Color ColorVA
        {
            get { return COLORVA; }
            set { COLORVA = value; }
        }
        [Browsable(false)]
        public string VAColorSerialize
        {
            get { return Gui.Design.SerializableColor.ToString(COLORVA); }
            set { COLORVA = Gui.Design.SerializableColor.FromString(value); }
        }
        [Description("Out VA Color")]
        [Category("Settings : Colors")]
		[Gui.Design.DisplayName("Out ValueArea")]
        public Color ColorhVA
        {
            get { return COLORhVA; }
            set { COLORhVA = value; }
        }
        [Browsable(false)]
        public string hVAColorSerialize
        {
            get { return Gui.Design.SerializableColor.ToString(COLORhVA); }
            set { COLORhVA = Gui.Design.SerializableColor.FromString(value); }
        }
		[Description("POC Color")]
        [Category("Settings : Colors")]
		[Gui.Design.DisplayName("POC")]
        public Color ColorPOC
        {
            get { return COLORPOC; }
            set { COLORPOC = value; }
        }
        [Browsable(false)]
        public string POCColorSerialize
        {
            get { return Gui.Design.SerializableColor.ToString(COLORPOC); }
            set { COLORPOC = Gui.Design.SerializableColor.FromString(value); }
        }
		[Description("TPO Color")]
        [Category("Settings : Lettre")]
		[Gui.Design.DisplayName("Color")]
        public Color ColorTPO
        {
            get { return TPOColor; }
            set { TPOColor = value; }
        }

        [Browsable(false)]
        public string TPOColorSerialize
        {
            get { return Gui.Design.SerializableColor.ToString(TPOColor); }
            set { TPOColor = Gui.Design.SerializableColor.FromString(value); }
        }
		[Description("true : display Volume , false : hide Volume")]
        [Category("Settings : Volume")]
		[Gui.Design.DisplayName("\tDisplay")]
        public bool IVOLUME
        {
            get { return iVolume; }
            set { iVolume = value; }
        }
		[Description("true : display TPOCount , false : hide TPOCount")]
        [Category("Settings : TPOCount")]
		[Gui.Design.DisplayName("\tDisplay")]
        public bool ITPOCOUNT
        {
            get { return iTPOCount; }
            set { iTPOCount = value; }
        }
		[Description("true : display Rotation Factor , false : hide Rotation Factor")]
        [Category("Settings : Rotation Factor")]
		[Gui.Design.DisplayName("\tDisplay")]
        public bool IRF
        {
            get { return iRF; }
            set { iRF = value; }
        }
		[Description("true : display POC & VA text , false : hide POC & VA text")]
        [Category("Settings : POC & VA (text)")]
		[Gui.Design.DisplayName("\tDisplay")]
        public bool IPOCVA
        {
            get { return iPOCVA; }
            set { iPOCVA = value; }
        }
        #endregion
		#region Miscellaneous
		private void VolTotMois()
		{
				nVolumeTotM += Volume[0];
		}

		
		private void VolTotSemaine()
		{
				nVolumeTotS += Volume[0];
		}
		
		private void VolTotJour()
		{
				nVolumeTot += Volume[0];
				nVolumeJ += Volume[0];
		}
		
		private void DiversAffichage()
		{
			int x = 0;

			if (Mode ==1) // début mode 1 (Weekly)
			{
				if (LEFTTORIGHT)
				{
					if (CurrentBar - BarCount >= 1 )
					{
						x = CurrentBar - BarCount;
						if (CurrentBar - Bars.BarsSinceSession > 0)
							x += 1;
						DrawText("ARROWOpen"+compteur, false, "", x, OpenSessionPrice, 0, Color.Black, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
						if (CurrentBar - Bars.BarsSinceSession > 0 &  iPOCVA)
						{
							x = CurrentBar - BarCount + nDigitLength*2;
							if (x < 0)
								x = 0;
							DrawText("TPOvzHighTp"+compteur,TPOHighZone.ToString(),x,TPOHighZone,Color.Green);
							DrawText("TPOvzLowTp"+compteur,TPOLowZone.ToString(),x,TPOLowZone,Color.Magenta);
							DrawText("TPOTp"+compteur,TPOPrice.ToString(),x,TPOPrice,Color.Red);
						}
					}
					
					if (derPos < 3)
						derPos = 0;
					else
						derPos -= 3;
					
					if (SessionCount > 1 )
						DrawText("ARROWClose"+compteur, false, "", derPos, Close[0], 0, Color.Magenta, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
				}
				else 
				{
					DrawText("ARROWOpen"+compteur, false, "", -1, OpenSessionPrice, 0, Color.Black, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
					DrawText("ARROWClose"+compteur, false, "", derPosL+1, Close[0], 0, Color.Magenta, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
									
					if (iPOCVA)
					{
						DrawText("TPOvzHighTp"+compteur,TPOHighZone.ToString(),-(TPOHighZone.ToString().Length+Widthhpb),TPOHighZone,Color.Blue);
						DrawText("TPOvzLowTp"+compteur,TPOLowZone.ToString(),-(TPOLowZone.ToString().Length+Widthhpb),TPOLowZone,Color.Magenta);
						DrawText("TPOTp"+compteur,TPOPrice.ToString(),-(TPOPrice.ToString().Length+Widthhpb),TPOPrice,Color.Red);
					}
				}
				if (iVolume)
				{
					VolTotSemaine();
					if (LEFTTORIGHT)
						DrawText("Vol"+compteur,nVolumeTotS.ToString(),CurrentBar - BarCount-(TPOHigh/2) + WidthVol,l-(espace*2)+HighVol,Color.Black);
					else
						DrawText("Vol"+compteur,nVolumeTotS.ToString(), WidthVol,l-(espace*2) +HighVol,Color.Black);	
				}
			
			} // fin mode 1 (Weekly)
			else if (Mode == 2) // début mode 2 (Montly)
			{
				if (LEFTTORIGHT)
				{
					if (CurrentBar - BarCount >= 1)
					{
						x = CurrentBar - BarCount;
						DrawText("ARROWOpen"+compteur, false, "", x, OpenSessionPrice, 0, Color.Black, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
						if (CurrentBar - Bars.BarsSinceSession > 0 && iPOCVA)
						{
							x = CurrentBar - BarCount - TPOHigh - nDigitLength*2;
							if (x < 0)
								x = 0;
							DrawText("TPOvzHighTp"+compteur,TPOHighZone.ToString(),x,TPOHighZone,Color.Green);
							DrawText("TPOvzLowTp"+compteur,TPOLowZone.ToString(),x,TPOLowZone,Color.Magenta);
							DrawText("TPOTp"+compteur,TPOPrice.ToString(),x,TPOPrice,Color.Red);
						}
					}
			
					if (derPos < 3)
						derPos = 0;
					else
						derPos -= 3;
					
					if (compteur > 1 )
							DrawText("ARROWClose"+compteur, false, "", derPos, Close[0], 0, Color.Magenta, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
				}
				else
				{
					DrawText("ARROWOpen"+compteur, false, "", -1, OpenSessionPrice, 0, Color.Black, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
					DrawText("ARROWClose"+compteur, false, "", derPosL+1, Close[0], 0, Color.Magenta, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
									
					if (iPOCVA)
					{
						DrawText("TPOvzHighTp"+compteur,TPOHighZone.ToString(),-(TPOHighZone.ToString().Length+Widthhpb),TPOHighZone,Color.Blue);
						DrawText("TPOvzLowTp"+compteur,TPOLowZone.ToString(),-(TPOLowZone.ToString().Length+Widthhpb),TPOLowZone,Color.Magenta);
						DrawText("TPOTp"+compteur,TPOPrice.ToString(),-(TPOPrice.ToString().Length+Widthhpb),TPOPrice,Color.Red);
					}
				}
				if (iVolume)
				{
					VolTotMois();
					if (LEFTTORIGHT)
						DrawText("Vol"+compteur,nVolumeTotM.ToString(),CurrentBar - BarCount-TPOHigh/2,l-(espace*2)+HighVol,Color.Black);
					else
						DrawText("Vol"+compteur,nVolumeTotM.ToString(), WidthVol,l-(espace*2) +HighVol,Color.Black);
				}
			} // fin mode 2 (montly)
			else // début mode 0 (daily)
			{
				Color POCColor = Color.Black ;
				if (currentDate == Bars.GetTradingDayFromLocal(Time[0]))
				{
					POCColor = Color.Black ;
					if (TPOPrice > prevPOC)
						POCColor = Color.Green ;
					else if (TPOPrice < prevPOC)
						POCColor = Color.Red ;
					else
						POCColor = Color.Black ;
				}
				else
					POCColor = Color.Red ;
							
				if (LEFTTORIGHT)
				{
					if (CurrentBar - Bars.BarsSinceSession > 0 && iPOCVA)
					{
						x = CurrentBar - BarCount + nDigitLength;
						if (x < 0)
							x = 0;
						DrawText("TPOvzHighTp"+compteur,TPOHighZone.ToString(),x+Widthhpb,TPOHighZone,Color.Blue);
						DrawText("TPOvzLowTp"+compteur,TPOLowZone.ToString(),x+Widthhpb,TPOLowZone,Color.Magenta);
						DrawText("TPOTp"+compteur,TPOPrice.ToString(),x+Widthhpb,TPOPrice,POCColor);

					}
					x = derPos;
					if (x > 2)
						x -= 2;
					DrawText("ARROWClose"+compteur, false, "", x, Close[0], 0, Color.Magenta, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;					
					
					x = CurrentBar - BarCount;
					if (CurrentBar - Bars.BarsSinceSession > 0)
						x += 1;
					if (compteur > 1 )
						DrawText("ARROWOpen"+compteur, false, "", x, OpenSessionPrice, 0, Color.Black, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
				}
				else 
				{
					DrawText("ARROWOpen"+compteur, false, "", -1, OpenSessionPrice, 0, Color.Black, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
					DrawText("ARROWClose"+compteur, false, "", derPosL+1, Close[0], 0, Color.Magenta, Arrow, StringAlignment.Center, Color.Transparent, Color.Transparent,0) ;
 
					if (iPOCVA)
					{
						DrawText("TPOvzHighTp"+compteur,TPOHighZone.ToString(),-(TPOHighZone.ToString().Length+Widthhpb),TPOHighZone,Color.Blue);
						DrawText("TPOvzLowTp"+compteur,TPOLowZone.ToString(),-(TPOLowZone.ToString().Length+Widthhpb),TPOLowZone,Color.Magenta);
						DrawText("TPOTp"+compteur,TPOPrice.ToString(),-(TPOPrice.ToString().Length+Widthhpb),TPOPrice,POCColor);
					}
				}
				if (iVolume)
				{
					VolTotJour();
					string txtVol = (nVolumeTot/compteur).ToString("0") + " - " + (nVolumeJ).ToString();
					if (LEFTTORIGHT)
						x =CurrentBar - BarCount-TPOHigh/2;
					else
						x = txtVol.Length / 2;
					if (nVolumeJ >= nVolumeTot/compteur)
						DrawText("Vol"+compteur,txtVol,x + WidthVol,l-(espace*2)+HighVol,Color.Green);
					else
						DrawText("Vol"+compteur,txtVol,x + WidthVol,l-(espace*2)+HighVol ,Color.Red);
				}
			} // fin mode 0
		} // affichage
		
		private void TPOF()
		{
			if(CurrentBar == 0)
					return;
			
			if (nBars > 0)
			{
				if  (CurrentBar >= 1) 
					{
						if (High[0] > High[1])
							hTPOF += 1;
						else if (High[0] < High[1])
							hTPOF -= 1;
						if (Low[0] > Low[1])
							bTPOF += 1;
						else if (Low[0] < Low[1])
							bTPOF -= 1;		
					}
				if (hTPOF +bTPOF >= 0)
					TPOFColor = Color.Green;
				else
					TPOFColor = Color.Red;	
	
				if (LEFTTORIGHT)
						DrawText("hT" + compteur,(hTPOF +bTPOF).ToString(),CurrentBar - BarCount + Widthtrf,h+espace+HighRF,TPOFColor);
				else
						DrawText("hT" + compteur,(hTPOF +bTPOF).ToString(),Widthtrf,h+espace+HighRF,TPOFColor);

			}
			nBars += 1;
		} // fin TPOF
		
		private void CalculateIB(double h, double l)
		{		
			if (merge)
			{
				if (firstBars == 0)
				{
					if (ToTime(OPENHOUR+1,OPENMINUTE,0) == ToTime(Time[0]))
					{
						highestHigh = h;
						lowestLow = l;
					}
				}
			}
			else if (ToTime(OPENHOUR+1,OPENMINUTE,0) == ToTime(Time[0]))
			{
				highestHigh = h;
				lowestLow = l;
			}
			if (!IBPersistant)
			{
				if (currentDate == Bars.GetTradingDayFromLocal(Time[0]))
				{
					if (highestHigh != 0 && lowestLow != 0)
					{
						IB_High.Set(highestHigh);
						IB_Low.Set(lowestLow);
						if (SHOWIBEXT)
						{
							double diff = highestHigh - lowestLow;
							IB_Ext_h1.Set(highestHigh + (diff*IBCoef1));
							IB_Ext_h2.Set(highestHigh + (diff*IBCoef2));
							IB_Ext_h3.Set(highestHigh + (diff*IBCoef3));
							IB_Ext_h4.Set(highestHigh + (diff*IBCoef4));
							IB_Ext_l1.Set(lowestLow - (diff*IBCoef1));
							IB_Ext_l2.Set(lowestLow - (diff*IBCoef2));
							IB_Ext_l3.Set(lowestLow - (diff*IBCoef3));
							IB_Ext_l4.Set(lowestLow - (diff*IBCoef4));
						}
					}
				}
			}
			else
				{
					if (highestHigh != 0 && lowestLow != 0)
					{
						IB_High.Set(highestHigh);
						IB_Low.Set(lowestLow);
						if (SHOWIBEXT)
						{
							double diff = highestHigh - lowestLow;
							IB_Ext_h1.Set(highestHigh + (diff*IBCoef1));
							IB_Ext_h2.Set(highestHigh + (diff*IBCoef2));
							IB_Ext_h3.Set(highestHigh + (diff*IBCoef3));
							IB_Ext_h4.Set(highestHigh + (diff*IBCoef4));
							IB_Ext_l1.Set(lowestLow - (diff*IBCoef1));
							IB_Ext_l2.Set(lowestLow - (diff*IBCoef2));
							IB_Ext_l3.Set(lowestLow - (diff*IBCoef3));
							IB_Ext_l4.Set(lowestLow - (diff*IBCoef4));
						}
					}
				}

		} // fin IB
		
		private void TPOCount()
		{				
			Color TPOCountColor = Color.Black;
	
			int x = 0;
			int countb = 0;
			while (x < TPOIndex)
			{
				if (TextTrack[x] >1)
					countb = countb + TextTrack[x];
				x++;
			}
			x = 0;
			int counth = 0;
			while (x < HighIndex-TPOIndex)
			{
				if (TextTrack[HighIndex-x] >1)
					counth = counth + TextTrack[HighIndex-x];
				x++;
			}
		
			string TPOCountT = (TPOTotal).ToString() + " ( " + (counth).ToString() + " / " + (countb).ToString() +" )";
			
			int debutT = CurrentBar - BarCount - (TPOCountT.Length);
			if (debutT < 3)
				debutT = 0;
			else
				debutT = debutT + 3;
			
			if (counth > countb)
				TPOCountColor = Color.Red;
			else
				TPOCountColor = Color.Green;
		
			if (LEFTTORIGHT)
			{
				if (Mode == 1 || Mode == 2)
					DrawText("TPOCount"+compteur,TPOCountT,CurrentBar - BarCount - (TPOHigh/2) + Widthtpoc ,h+(espace*4)+HighTPOC,TPOCountColor);
				else
					DrawText("TPOCount"+compteur,TPOCountT,CurrentBar - BarCount - (TPOHigh/2) + Widthtpoc ,h+(espace*2)+HighTPOC,TPOCountColor);
			}
			else
			{
				if (Mode == 1 || Mode == 2)
					DrawText("TPOCount"+compteur,TPOCountT,(TPOHigh/2) + Widthtpoc ,h+(espace*4)+HighTPOC,TPOCountColor);
				else
					DrawText("TPOCount"+compteur,TPOCountT,(TPOHigh/2) + Widthtpoc ,h+(espace*2)+HighTPOC,TPOCountColor);
			}
		}
		
		private void InitVar()
		{
			Tracker = true;
			FirstStart = false;
			HighIndex = 0;
			LowIndex = 999999;
			TPOHigh = 0;
			BarCount = CurrentBar - 1;
			//SessionCount = SessionCount + 1;
			if (Mode == 0)
				SessionCount = compteur - 1;
			else
				SessionCount = SessionCount + 1;
			int x = 0;
			while (x < 50000)
			{
				TextTrack[x] = 0;
				TextIndex[x] = 0;
				x++;
			}
			OpenSessionPrice = Open[0];
			nDigit = PriceFormat(TickSize);
			nDigitLength = OpenSessionPrice.ToString().Length;
			if (nDigit == "G")
				espace = Math.Round(TickSize, 0, MidpointRounding.AwayFromZero)*3;
			else if (nDigit == "F1")
				espace = TickSize*8;
			else
				espace = TickSize*3;

			h = High[0];
			l = Low[0];
			c = Close[0];
			highestHigh = 0;
			lowestLow = 0;
			nVolumeJ = 0;
			nBars = 0;
			hTPOF = bTPOF = 0 ;
			tmpFirstStart = false;
			nVolumeTotS = 0;
			nVolumeTotM = 0;
			if (Mode == 2)
				ancienMois = nouveauMois;
		}
		
		private void MP()
		{
			h = Math.Max(High[0], h);
			l = Math.Min(Low[0], l);
			DrawMPText();
			CalcTPOLine();
		}
		
		private void CalcTPOLine()
		{
			if (CalcVar == true && HighIndex - LowIndex != 0)	
			{	
			CalcVar = false;
			TPOTotal = 0;
			int x = 0;
			while (x < HighIndex)
			{
				TPOTotal = TPOTotal + TextTrack[x];
				x++;
			}
			
			CenterIndex = Convert.ToInt32(Math.Round((HighIndex - LowIndex) * 0.5, 0, MidpointRounding.AwayFromZero));
			x = 0;
								
			while (x <= CenterIndex && CenterIndex != 0)
			{
				if (TextTrack[CenterIndex + LowIndex + x] == TPOHigh)
				{
					TPOIndex = CenterIndex + LowIndex + x;
					break;
				}
				else if (TextTrack[CenterIndex + LowIndex - x] == TPOHigh)
				{
					TPOIndex = CenterIndex + LowIndex - x;
					break;
				}
				else
					x++;	
			}
			
			TPOPrice = (OpenSessionPrice + (TPOIndex - ArrayMid) * TickSize) > h ? h : (OpenSessionPrice + (TPOIndex - ArrayMid) * TickSize);
			TPOPrice = (OpenSessionPrice + (TPOIndex - ArrayMid) * TickSize) < l ? l : (OpenSessionPrice + (TPOIndex - ArrayMid) * TickSize);
			TPOZone = Convert.ToInt32(Math.Round(TPOTotal * TPOValZone * .01, 0, MidpointRounding.AwayFromZero));
			
			x= TextTrack[TPOIndex];
			int y = 1;
			int z = 1;
			int upTPO;
			int dnTPO;
			
			while (x <= TPOZone)
				
			{
				upTPO = TextTrack[TPOIndex + y] + TextTrack[TPOIndex + y + 1];
				dnTPO = TextTrack[TPOIndex - z] + TextTrack[TPOIndex - z - 1];
				if (upTPO == dnTPO)
				{
					x = x + upTPO + dnTPO;
					TPOvzHigh = TPOIndex + y + 1;
					TPOvzLow = TPOIndex - z - 1;
					y = y + 2;
					z = z + 2;
				}
				else if (upTPO > dnTPO)
				{
					x = x + upTPO;
					TPOvzHigh = TPOIndex + y + 1;
					y = y + 2;
					if (z == 1)
						TPOvzLow = TPOIndex;
				}
				else if (upTPO < dnTPO)
				{
					x = x + dnTPO;
					TPOvzLow = TPOIndex - z - 1;
					z = z + 2;
					if (y == 1)
						TPOvzHigh = TPOIndex;
				}
				
			}
			
			TPOHighZone = (OpenSessionPrice + (TPOvzHigh - ArrayMid) * TickSize) > h ? h : (OpenSessionPrice + (TPOvzHigh - ArrayMid) * TickSize);
			TPOLowZone = (OpenSessionPrice + (TPOvzLow - ArrayMid) * TickSize) < l ? l : (OpenSessionPrice + (TPOvzLow - ArrayMid) * TickSize);
			}
		}
		
		private void DrawProfile()
		{
			Color tmp = Color.Green;
			int x = LowIndex;
			while (x <= HighIndex)
			{
				if ((OpenSessionPrice + (x - ArrayMid) * TickSize) == TPOPrice)
					tmp = COLORPOC;
				else if (((OpenSessionPrice + (x - ArrayMid) * TickSize) > TPOHighZone) || ((OpenSessionPrice + (x - ArrayMid) * TickSize) < TPOLowZone) )
					tmp = COLORhVA;
				else
					tmp = COLORVA;
					
				if (LEFTTORIGHT)
					DrawRectangle("Rect" + SessionCount.ToString() + x.ToString(), false, CurrentBar - BarCount , OpenSessionPrice + (x - ArrayMid) * TickSize-TickSize, CurrentBar - BarCount - TextTrack[x], OpenSessionPrice + (x - ArrayMid) * TickSize, Color.Transparent, tmp, Opacity);
				else
					DrawRectangle("Rect" + SessionCount.ToString() + x.ToString(), false, 0 , OpenSessionPrice + (x - ArrayMid) * TickSize-TickSize, TextTrack[x], OpenSessionPrice + (x - ArrayMid) * TickSize, Color.Transparent, tmp, Opacity);
				x++;
			}
		}
	

		private void DrawMPText()
		{
			ChoixText();
			UpIndex = Convert.ToInt32(Math.Round((High[0] - Open[0]) / TickSize, 0, MidpointRounding.AwayFromZero));
			DnIndex = Convert.ToInt32(Math.Round((Open[0] - Low[0]) / TickSize, 0, MidpointRounding.AwayFromZero));
			int y = 0;
			while (y <= UpIndex)
			{
				ArrayIndex = Convert.ToInt32(Math.Round((ArrayMid + ((Open[0] + y * TickSize) - OpenSessionPrice) / TickSize), 0, MidpointRounding.AwayFromZero));
				if (ArrayIndex > HighIndex)
					HighIndex = ArrayIndex;
				if (ArrayIndex < LowIndex)
					LowIndex = ArrayIndex;
				if (CurrentBar - BarCount > TextIndex[ArrayIndex])
				{
					if ((Mode ==0 && Lettre) && (PROFILE == 0 || PROFILE == 1))
						DrawText("Text" + ArrayIndex + CurrentBar, false, TPOT, CurrentBar - BarCount - TextTrack[ArrayIndex], Open[0] + y * TickSize, 0, TPOColor, textFont, StringAlignment.Center , Color.Transparent, Color.Transparent, 0) ;
					if (Open[0] + y * TickSize == Close[0])
					{
						derPos = CurrentBar - BarCount - TextTrack[ArrayIndex];
						derPosL = TextTrack[ArrayIndex];
					}
					TextTrack[ArrayIndex] = TextTrack[ArrayIndex] + 1;
					if (TextTrack[ArrayIndex] > TPOHigh)
						TPOHigh = TextTrack[ArrayIndex];
					TextIndex[ArrayIndex] = CurrentBar - BarCount;
					CalcVar = true;
					
				}
				y++;
			}
			y = 1;
			while (y <= DnIndex)
				{
					ArrayIndex = Convert.ToInt32(Math.Round((ArrayMid + ((Open[0] - y * TickSize) - OpenSessionPrice) / TickSize), 0, MidpointRounding.AwayFromZero));
				if (ArrayIndex > HighIndex)
					HighIndex = ArrayIndex;
				if (ArrayIndex < LowIndex)
					LowIndex = ArrayIndex;
				if (CurrentBar - BarCount > TextIndex[ArrayIndex] || CurrentBar - BarCount == 0)
				{
					if ((Mode ==0 && Lettre) && (PROFILE == 0 || PROFILE == 1))
						DrawText("Text" + ArrayIndex + CurrentBar, false, TPOT, CurrentBar - BarCount - TextTrack[ArrayIndex], Open[0] - y * TickSize, 0, TPOColor, textFont, StringAlignment.Center , Color.Transparent, Color.Transparent, 0) ;
					if (Open[0] - y * TickSize == Close[0])
					{
						derPos = CurrentBar - BarCount - TextTrack[ArrayIndex];
						derPosL = TextTrack[ArrayIndex];
					}
					TextTrack[ArrayIndex] = TextTrack[ArrayIndex] + 1;
					if (TextTrack[ArrayIndex] > TPOHigh)
						TPOHigh = TextTrack[ArrayIndex];
					TextIndex[ArrayIndex] = CurrentBar - BarCount;
					CalcVar = true;
				}
				y++;
			}
		}
		
		private void ChoixText()
		{
			textFont = new Font("Verdana",TAILLEL);
			if (CurrentBar - BarCount <= 52)
				TPOT = letters.Substring(CurrentBar - BarCount, 1);
			else
			{
				decimal Value1 = (CurrentBar - BarCount) / 52;
				TPOT = letters.Substring(Convert.ToInt32(CurrentBar - BarCount - Math.Floor(Value1) * 52), 1);
			}
		}
		
		private DateTime RoundUpTimeToPeriodTime(DateTime time)
		{
			DateTime result = new DateTime(time.Year, time.Month, 1); 
			return result.AddMonths(1).AddDays(1);
		}

		public string PriceFormat(double TickSize)
		{
			short Precision = 0;
			while (TickSize % 1 > 0.0)
			{
			TickSize *= 10;
			Precision++;
			}
			return Precision == 0 ? "G" : "F" + Precision;
		}
		#endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private iMarketProfile2_7[] cacheiMarketProfile2_7 = null;

        private static iMarketProfile2_7 checkiMarketProfile2_7 = new iMarketProfile2_7();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public iMarketProfile2_7 iMarketProfile2_7()
        {
            return iMarketProfile2_7(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public iMarketProfile2_7 iMarketProfile2_7(Data.IDataSeries input)
        {
            if (cacheiMarketProfile2_7 != null)
                for (int idx = 0; idx < cacheiMarketProfile2_7.Length; idx++)
                    if (cacheiMarketProfile2_7[idx].EqualsInput(input))
                        return cacheiMarketProfile2_7[idx];

            lock (checkiMarketProfile2_7)
            {
                if (cacheiMarketProfile2_7 != null)
                    for (int idx = 0; idx < cacheiMarketProfile2_7.Length; idx++)
                        if (cacheiMarketProfile2_7[idx].EqualsInput(input))
                            return cacheiMarketProfile2_7[idx];

                iMarketProfile2_7 indicator = new iMarketProfile2_7();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                iMarketProfile2_7[] tmp = new iMarketProfile2_7[cacheiMarketProfile2_7 == null ? 1 : cacheiMarketProfile2_7.Length + 1];
                if (cacheiMarketProfile2_7 != null)
                    cacheiMarketProfile2_7.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheiMarketProfile2_7 = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.iMarketProfile2_7 iMarketProfile2_7()
        {
            return _indicator.iMarketProfile2_7(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.iMarketProfile2_7 iMarketProfile2_7(Data.IDataSeries input)
        {
            return _indicator.iMarketProfile2_7(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.iMarketProfile2_7 iMarketProfile2_7()
        {
            return _indicator.iMarketProfile2_7(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.iMarketProfile2_7 iMarketProfile2_7(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.iMarketProfile2_7(input);
        }
    }
}
#endregion
